#ifndef _GLOBAL_H
#define _GLOBAL_H
/*
 *	$RCSfile: global.h $		$Revision: 1.0 $
 *
 *	Project wide global definitions header
 *
 *	Graham E. Kinns			Borland C++ v4.01 (patched)
 *
 *	$Log: global.h $
 *		Revision 1.0  1995/10/30  21:04:01  Graham
 *		Initial revision
 *
 */

#include "config.h"
/*#include "debug.h"*/	/*  Include Debug whether DEBUG def'd or not
			 *  for dummy DEBUG_PRINTF macros
			 */

/*  custom type definitions  */

typedef enum { FALSE, TRUE } Bool;	/*  Boolean type  */

typedef unsigned char	Byte;		/*   8 bit  */
typedef unsigned int	Word;		/*  16 bit  */
typedef unsigned long	DWord;		/*  32 bit  */

/*  LSN - Logical Sector Number custom type  */
typedef Word	LSN;

/*  Various NULL pointer macros  */
#ifndef NULL
#  define NULL (void *) 0
#endif

#define NULL_CPTR (char *) NULL
#define NULL_BPTR (Byte *) NULL
#define NULL_WPTR (Word *) NULL

/*  Used on the PC Bios routines to point to a block of memory  */
#ifdef IBMPC
typedef Byte far *	MemPtr;
#else
typedef char *	MemPtr;
#endif

#ifdef IBMPC
/*  Macros for segment:offset <-> absolute DWord addresses  */
#define FARPTR_TO_DWORD( p ) (DWord) ((((DWord)(Word) FP_SEG( (p) ) ) << 4 ) \
	                            + ( (DWord)(Word) FP_OFF( (p) )        ) )
#define DWORD_SEG(d) ((Word) ((d) >> 4) & 0xffff )
#define DWORD_OFF(d) (((Word) (d)) & 0x000f )

#define DWORD_TO_FARPTR(d) (MK_FP( dword_seg((d)), dword_off((d)) ))

#define FARPTR_CMP( p1, p2 ) ( (FARPTR_TO_DWORD((p1))) == (FARPTR_TO_DWORD((p2))) )

#endif

/*  globally available functions  */

void	internal_error( const char *fmt, ... );

#endif  /*  _GLOBAL_H  */
