/*
 *	$RCSfile: msdos.c $		$Revision: 1.0 $
 *
 *	MsDos level O/S interface functions
 *
 * 	Graham E. Kinns
 *
 *	$Log: msdos.c $
 *		Revision 1.0  1995/10/30  21:06:51  Graham
 *		Initial revision
 *
 */
#ifdef RCS
  static const char	RCS_id[] = "$Id: msdos.c 1.0 1995/10/30 21:06:51 Graham Exp $";
#endif /* RCS */

#include <dos.h>

#include "global.h"
#include "msdos.h"

void	msdos_get_interrupt ( Byte int_num, Word *int_segment, Word *int_offset )
/*  Ask Dos nicely to get the software interrupt vector for int_num  */
{
	union	REGS	regs;
	struct	SREGS	segregs;

	regs.h.ah = 0x35;	/* Dos Service 35h, get interrupt vector into ES:BX  */
	regs.h.al = int_num;

	(void) intdosx( &regs, &regs, &segregs );
	/*  Doesn't fail  */

	*int_segment = (Word) segregs.es;
	*int_offset  = (Word) regs.x.bx;
}

void	msdos_set_interrupt ( Byte int_num, Word int_segment, Word int_offset )
/*  Ask Dos nicely to set the software interrupt vector for int_num  */
{
	union	REGS	regs;
	struct	SREGS	segregs;

	regs.h.ah  = 0x25;	/* Dos Service 25h, set interrupt vector to DS:DX  */
	regs.h.al  = int_num;
	segregs.ds = int_segment;
	regs.x.dx  = int_offset;

	(void) intdosx( &regs, &regs, &segregs );
	/*  Doesn't fail  */
}

